/*
  Example of usage of namespace

 */
 
#include <iostream>

namespace first_namespace {
  float prod( float & a, float & b ) {
    return a*b ;
  }
  float add( float & a, float & b ) {
    return a+b ;
  }
}

namespace second_namespace {
  float prod( float & a, float & b ) {
    return float(double(a)*double(b)) ; // double(a) --> conversion operator
  }
  float add( float & a, float & b ) { // bugged addition
    return a-b ;
  }
}

int a ;

int
main() {
  float a = 1 ;
  float b = 2 ;
  
  {
    float c ;
  
  }
  
  // access to prod  of namespace first_namespace
  std::cout << first_namespace::prod(a,b) << '\n' ;
  std::cout << "good addition " << first_namespace::add(a,b)  << '\n' ;
  std::cout << "bugged addition " <<  second_namespace::add(a,b) << '\n' ;

  using namespace first_namespace ; // now all the functions and definition
                                    // of first_namespace are in the current scope

  std::cout << "good addition " << add(a,b) << '\n' ;

  using second_namespace::add ; // now add second_namespace is the the current scope
                                // and it replace the add of first_namespace
 
  std::cout << "good addition ??" << add(a,b) << '\n' ;
  return 0 ;
}