/*
  Example of usage of namespace

 */
 
#include <iostream>

namespace lib1 {

  using namespace std ;

  typedef int    indexType ;
  typedef double valueType ;

  float prod( float & a, float & b ) { cout << "pass lib1::prod\n" ; return a*b ; }
  float add(  float & a, float & b ) { cout << "pass lib1::add\n"  ; return a+b ; }
  float div(  float & a, float & b ) { cout << "pass lib1::div\n"  ; return a/b ; }
}

namespace lib2 {

  using namespace std ;

  typedef int    indexType ;
  typedef double valueType ;

  float prod( float & a, float & b ) { cout << "pass lib2::prod\n" ; return a*b ; }
  float add(  float & a, float & b ) { cout << "pass lib2::add\n" ; return a+b ; }
  float div(  float & a, float & b ) { cout << "pass lib2::div\n" ; return a/b ; }
}

int a_global = 123 ;

static int a_local = 222 ;

int fact( int n ) {
  int res = 1 ;
  for ( int i = 1 ; i <= n  ; ++i ) res *= i ;
  return res ;
}

static
int fact1( int n ) {
  int res = 1 ;
  for ( int i = 1 ; i <= n  ; ++i ) res *= i ;
  return res ;
}

int
main() {
  float a = 1 ;
  float b = 2 ;

  { // local block 
    using namespace lib1 ;
    double c = prod(a,b) ;
    double d = add(a,b) ;
    double e = div(a,b) ;
  }

  { // local block 
    using namespace lib2 ;
    double c = prod(a,b) ;
    double d = add(a,b) ;
    double e = div(a,b) ;
  }
  return 0 ;
}