#ifndef GAUSSLU_HH
#define GAUSSLU_HH

namespace gaussLU {

  typedef double   valueType ;
  typedef unsigned indexType ;

  valueType
  factorize( indexType const n,      /* Number of rows and columns of matrix A */
             valueType       A[],    /* Pointer to coefficients of A           */
             indexType const lda,    /* Leading dimension of A, Fortran style  */
             indexType       perm[], /* Permutation vector                     */
             valueType       work[] ) ;

  valueType
  factorBlock( indexType const n,      /* Number of rows and columns of matrix A */
               valueType       A[],    /* Pointer to coefficients of A           */
               indexType const lda,    /* Leading dimension of A, Fortran style  */
               indexType       perm[], /* Permutation vector                     */
               valueType       work[] ) ;

  void
  solve( indexType const n,      /* Number of rows and columns of matrix A */
         valueType const LU[],   /* Pointer to coefficients of LU          */
         indexType const lda,    /* Leading dimension of LU, Fortran style */
         indexType const perm[], /* Permutation vector                     */
         valueType       b[]     /* Pointer to coefficients of vector b    */ ) ;

  void
  solveTranspose( indexType const n,      /* Number of rows and columns of matrix A */
                  valueType const LU[],   /* Pointer to coefficients of LU          */
                  indexType const lda,    /* Leading dimension of LU, Fortran style */
                  indexType const perm[], /* Permutation vector                     */
                  valueType       b[]     /* Pointer to coefficients of vector b    */ ) ;

}

#endif